#ifndef I8042_HPP
#define I8042_HPP

#include "ps2.hpp"
#include "ps2_keyboard.hpp"
#include "ps2_mouse.hpp"
#include "socket.hpp"

/**
 * PC Keyboard Controller
 *
 * This is a bit of an odd device.  In the original PC, the keyboard had a
 * on-board chip that debounced key presses and buffered keycodes that it then
 * sent over a serial line to the keyboard controller.  The keyboard controller
 * provided a clock signal and power to the keyboard and raised an interrupt
 * to the processor that let software know when to read from the keyboard.  It
 * then facilitated communication to the microcontroller on the keyboard itself.
 *
 * The IBM PS/2 introduced a new port design and added the ability to support
 * an additional device (referred to as the AUX device).  This device is always
 * a mouse though.  The device is similar to the keyboard in many ways but has
 * a different command set.
 *
 * So while the i8042 supports multiple devices, it specifically only supports
 * a keyboard and a mouse and the ports are not interchangable (even though
 * they use the same pin layout).
 *
 * But this isn't the weird part.
 *
 * In the original PC, the 8088 processor only had 20 address lines which
 * allowed it to address a maximum of 1MB of memory.  The PS/2 included an
 * updated 80286 processor with a whooping 24 address lines.
 *
 * While the 8088 only had 20 address lines, the 20 bit segment base + 16-bit
 * segment offset could generate an address up to 0x10FFEF which overflows a
 * 20 bit address.  On the 8088, addresses like this were simply truncated to
 * 20 bits yielding 0x0FFEF.
 *
 * There was a bug in the 80286 processor though that did not truncate properly
 * when in real mode.  This broke compatibility with programs that relied on
 * this truncating behavior.
 *
 * In an attempt to save the day and provide 100% compatibility, IBM decided to
 * fix the bug on the main board by adding a switch to the address lines coming
 * out of the processor that would force the 20th address bit low regardless of
 * the address generated by the processor.  This made the system startup
 * in a compatible mode even with the buggy 80286.  When searching for a way to
 * let software disable this switch to enable full 24-bit memory access, they
 * found a free out pin on the i8042 chipset and used that.
 *
 * Of course, this meant that there was no way to get back into compatible real
 * mode within the processor alone since the a20 masking happens outside of
 * the processor.  To work around this, IBM also used another pin on the i8042
 * to issue a reset that would include resetting the a20 pin.
 *
 * By doing some magic in the BIOS and relying on the fact that memory contents
 * aren't wiped by a reset, this lets a user initiate a "switch" into real mode
 * using the keyboard controller.
 *
 * Note that the 0x92 port (System Control Port A) was a later addition because
 * communicating with the i8042 was pretty slow.  It also makes it possible to
 * build systems without keyboard controllers.
 *
 * Pretty awesome, eh?
 */

class I8042 : public Device, public PS2Controller
{
public:
    I8042(void);

    void data_ready(PS2Device *device);

    uint32_t read_data(void);
    void write_data(uint32_t val);

    uint32_t read_status(void);
    void write_command(uint32_t val);

    /* It's not right to embed this in the i8042 but it's easier to keep
     * the two mechanisms consistent this way */
    uint8_t read_scpa(void);
    void write_scpa(uint8_t val);

    void reset(void);
    void pickle(Marshaller *m, const char *name);

    void insert_kbd(PS2Keyboard *kbd);
    void insert_aux(PS2Mouse *aux);

    Socket<PS2Keyboard> kbd;
    Socket<PS2Mouse> aux;

    Pin irq_kbd;
    Pin irq_aux;

    Pin a20_line;
    Pin reset_line;

private:
    void update_irq(void);

    uint8_t write_cmd; /* if non zero, write data to port 60 is expected */
    uint8_t status;
    uint8_t mode;
    uint8_t outport;
    /* Bitmask of devices with data available.  */
    uint8_t pending;
};

#endif
